/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* "%code top" blocks.  */
/* Line 349 of yacc.c  */
#line 1 "parser.yy"
 // -*-c++-*-
/*
   Copyright (C) 2014, 2015 Red Hat, Inc.
   This file is part of dwgrep.

   This file is free software; you can redistribute it and/or modify
   it under the terms of either

     * the GNU Lesser General Public License as published by the Free
       Software Foundation; either version 3 of the License, or (at
       your option) any later version

   or

     * the GNU General Public License as published by the Free
       Software Foundation; either version 2 of the License, or (at
       your option) any later version

   or both in parallel, as here.

   dwgrep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received copies of the GNU General Public License and
   the GNU Lesser General Public License along with this program.  If
   not, see <http://www.gnu.org/licenses/>.  */

#include "parser.hh"


/* Line 349 of yacc.c  */
#line 98 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"



/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 71 "parser.yy"

  #include <sstream>
  #include <iostream>

  #include "lexer.hh"
  #include "constant.hh"
  #include "tree_cr.hh"
  #include "builtin.hh"

  namespace
  {
    void
    yyerror (std::unique_ptr <tree> &t, yyscan_t lex,
	     vocabulary const &builtins, char const *s)
    {
      fprintf (stderr, "%s\n", s);
    }

    constant
    parse_int (strlit str)
    {
      const char *buf = str.buf;
      size_t len = str.len;

      bool sign = buf[0] == '-';
      if (sign)
	{
	  buf += 1;
	  len -= 1;
	}

      int base;
      constant_dom const *dom;
      if (len > 2 && buf[0] == '0' && (buf[1] == 'x' || buf[1] == 'X'))
	{
	  base = 16;
	  buf += 2;
	  len -= 2;
	  dom = &hex_constant_dom;
	}
      else if (len > 2 && buf[0] == '0' && (buf[1] == 'b' || buf[1] == 'B'))
	{
	  base = 2;
	  buf += 2;
	  len -= 2;
	  dom = &bin_constant_dom;
	}
      else if (len > 2 && buf[0] == '0' && (buf[1] == 'o' || buf[1] == 'O'))
	{
	  base = 8;
	  buf += 2;
	  len -= 2;
	  dom = &oct_constant_dom;
	}
      else if (len > 1 && buf[0] == '0')
	{
	  base = 8;
	  buf += 1;
	  len -= 1;
	  dom = &oct_constant_dom;
	}
      else
	{
	  base = 10;
	  dom = &dec_constant_dom;
	}

      size_t pos;
      uint64_t val = std::stoull ({buf, len}, &pos, base);
      if (pos < len)
	throw std::runtime_error
	    (std::string ("Invalid integer literal: `") + str.buf + "'");

      mpz_class ret = val;
      if (sign)
	ret = -ret;

      return constant {ret, dom};
    }

    std::unique_ptr <tree>
    parse_word (vocabulary const &builtins, std::string str)
    {
      if (auto bi = builtins.find (str))
	return tree::create_builtin (bi);
      else
	return tree::create_str <tree_type::READ> (str);
    }

    std::unique_ptr <tree>
    tree_for_id_block (vocabulary const &builtins,
		       std::unique_ptr <std::vector <std::string>> ids)
    {
      std::unique_ptr <tree> ret;
      for (auto const &s: *ids)
	if (builtins.find (s) == nullptr)
	  {
	    std::unique_ptr <tree> t {tree::create_str <tree_type::BIND> (s)};
	    ret = tree::create_cat <tree_type::CAT>
	      (std::move (ret), std::move (t));
	  }
	else
	  throw std::runtime_error
	      (std::string ("Can't rebind a builtin: `") + s + "'");

      return ret;
    }

    std::unique_ptr <tree>
    nop ()
    {
      return tree::create_nullary <tree_type::NOP> ();
    }

    std::unique_ptr <tree>
    maybe_nop (std::unique_ptr <tree> t)
    {
      return t != nullptr ? std::move (t) : nop ();
    }

    std::unique_ptr <tree>
    wrap_in_scope_unless (tree_type tt, std::unique_ptr <tree> t)
    {
      auto ret = maybe_nop (std::move (t));
      if (ret->tt () != tt)
	ret = tree::create_scope (std::move (ret));
      return ret;
    }

    std::unique_ptr <tree>
    parse_op (vocabulary const &builtins,
	      std::unique_ptr <tree> a,
	      std::unique_ptr <tree> b,
	      std::string const &word)
    {
      return tree::create_assert
	(tree::create_ternary <tree_type::PRED_SUBX_CMP>
	 (maybe_nop (std::move (a)),
	  maybe_nop (std::move (b)),
	  tree::create_builtin (builtins.find (word))));
    }
  }

  fmtlit::fmtlit (bool a_raw)
    : t {tree_type::FORMAT}
    , level {0}
    , in_string {false}
    , raw {a_raw}
  {}

  void
  fmtlit::flush_str ()
  {
    t.take_child (tree::create_str <tree_type::STR> (str));
    str = "";
  }

  std::string
  fmtlit::yank_str ()
  {
    std::string tmp = str;
    str = "";
    return tmp;
  }

/* Line 371 of yacc.c  */
#line 271 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.hh".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_DWGREP_0_2_BUILD_LIBZWERG_PARSER_HH_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_DWGREP_0_2_BUILD_LIBZWERG_PARSER_HH_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
/* Line 387 of yacc.c  */
#line 33 "parser.yy"

  #include <memory>
  #include "tree.hh"

  struct strlit
  {
    const char *buf;
    size_t len;
  };

  // A helper structure that the lexer uses when parsing string
  // literals.
  struct fmtlit
  {
    std::string str;
    tree t;
    size_t level;
    bool in_string;
    bool raw;

    explicit fmtlit (bool a_raw);

    void flush_str ();
    std::string yank_str ();
  };


/* Line 387 of yacc.c  */
#line 331 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_LPAREN = 258,
     TOK_RPAREN = 259,
     TOK_LBRACKET = 260,
     TOK_RBRACKET = 261,
     TOK_LBRACE = 262,
     TOK_RBRACE = 263,
     TOK_QMARK_LPAREN = 264,
     TOK_BANG_LPAREN = 265,
     TOK_ASTERISK = 266,
     TOK_PLUS = 267,
     TOK_QMARK = 268,
     TOK_COMMA = 269,
     TOK_COLON = 270,
     TOK_SEMICOLON = 271,
     TOK_VBAR = 272,
     TOK_DOUBLE_VBAR = 273,
     TOK_ARROW = 274,
     TOK_ASSIGN = 275,
     TOK_IF = 276,
     TOK_THEN = 277,
     TOK_ELSE = 278,
     TOK_LET = 279,
     TOK_WORD = 280,
     TOK_OP = 281,
     TOK_LIT_STR = 282,
     TOK_LIT_INT = 283,
     TOK_DEBUG = 284,
     TOK_EOF = 285
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 258 "parser.yy"

  tree *t;
  strlit s;
  fmtlit *f;
  std::vector <std::string> *ids;
 

/* Line 387 of yacc.c  */
#line 384 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (std::unique_ptr <tree> &ret, void *yyscanner, vocabulary const &builtins);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */
/* "%code provides" blocks.  */
/* Line 387 of yacc.c  */
#line 60 "parser.yy"

  tree parse_query (vocabulary const &builtins, std::string str);
  tree parse_query (vocabulary const &builtins,
		    char const *begin, char const *end);

  // These two are for sub-expression parsing.
  tree parse_subquery (vocabulary const &builtins, std::string str);
  tree parse_subquery (vocabulary const &builtins,
		       char const *begin, char const *end);


/* Line 387 of yacc.c  */
#line 420 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_DWGREP_0_2_BUILD_LIBZWERG_PARSER_HH_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 427 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  32
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   78

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  31
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  11
/* YYNRULES -- Number of rules.  */
#define YYNRULES  33
/* YYNRULES -- Number of states.  */
#define YYNSTATES  65

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   285

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     6,     8,    10,    14,    16,    20,    22,
      26,    27,    30,    31,    33,    36,    37,    41,    46,    50,
      54,    57,    62,    67,    71,    77,    80,    83,    86,    93,
      95,    97,   101,   103
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      32,     0,    -1,    33,    30,    -1,    34,    -1,    35,    -1,
      35,    14,    34,    -1,    36,    -1,    36,    18,    35,    -1,
      37,    -1,    37,    26,    37,    -1,    -1,    41,    37,    -1,
      -1,    39,    -1,    25,    38,    -1,    -1,    17,    39,    17,
      -1,     3,    40,    33,     4,    -1,     9,    33,     4,    -1,
      10,    33,     4,    -1,     5,     6,    -1,     5,    40,    33,
       6,    -1,     7,    40,    33,     8,    -1,    19,    39,    16,
      -1,    24,    39,    20,    33,    16,    -1,    41,    11,    -1,
      41,    12,    -1,    41,    13,    -1,    21,    41,    22,    41,
      23,    41,    -1,    28,    -1,    25,    -1,    25,    15,    41,
      -1,    27,    -1,    29,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   273,   273,   279,   289,   291,   305,   307,   321,   323,
     336,   338,   351,   355,   358,   366,   370,   374,   390,   401,
     413,   420,   435,   449,   466,   482,   505,   518,   526,   540,
     543,   546,   554,   564
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_LPAREN", "TOK_RPAREN",
  "TOK_LBRACKET", "TOK_RBRACKET", "TOK_LBRACE", "TOK_RBRACE",
  "TOK_QMARK_LPAREN", "TOK_BANG_LPAREN", "TOK_ASTERISK", "TOK_PLUS",
  "TOK_QMARK", "TOK_COMMA", "TOK_COLON", "TOK_SEMICOLON", "TOK_VBAR",
  "TOK_DOUBLE_VBAR", "TOK_ARROW", "TOK_ASSIGN", "TOK_IF", "TOK_THEN",
  "TOK_ELSE", "TOK_LET", "TOK_WORD", "TOK_OP", "TOK_LIT_STR",
  "TOK_LIT_INT", "TOK_DEBUG", "TOK_EOF", "$accept", "Query", "Program",
  "AltList", "OrList", "OpList", "StatementList", "IdListOpt", "IdList",
  "IdBlockOpt", "Statement", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    31,    32,    33,    34,    34,    35,    35,    36,    36,
      37,    37,    38,    38,    39,    40,    40,    41,    41,    41,
      41,    41,    41,    41,    41,    41,    41,    41,    41,    41,
      41,    41,    41,    41
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     1,     1,     3,     1,     3,     1,     3,
       0,     2,     0,     1,     2,     0,     3,     4,     3,     3,
       2,     4,     4,     3,     5,     2,     2,     2,     6,     1,
       1,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      10,    15,    15,    15,    10,    10,     0,     0,     0,    30,
      32,    29,    33,     0,     0,     3,     4,     6,     8,    10,
       0,    10,    20,    10,    10,     0,     0,    12,     0,     0,
       0,     0,     1,     2,    10,    10,    10,    25,    26,    27,
      11,     0,     0,     0,     0,    18,    19,    14,    13,    23,
       0,    10,    31,     5,     7,     9,    16,    17,    21,    22,
       0,     0,     0,    24,    28
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    13,    14,    15,    16,    17,    18,    47,    28,    21,
      19
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -19
static const yytype_int8 yypact[] =
{
      32,   -11,     2,   -11,    32,    32,   -15,    32,   -15,    12,
     -19,   -19,   -19,    30,   -18,   -19,    20,    22,    10,     4,
     -15,    32,   -19,    32,    32,    40,    42,   -15,    31,    54,
      29,    32,   -19,   -19,    32,    32,    32,   -19,   -19,   -19,
     -19,    33,    48,    52,    46,   -19,   -19,   -19,   -19,   -19,
      32,    32,    57,   -19,   -19,   -19,   -19,   -19,   -19,   -19,
      51,    55,    32,   -19,    57
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -19,   -19,    -3,    38,    43,   -19,   -14,   -19,    18,     1,
      -7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      29,    25,    26,    23,    24,    40,    20,     1,    22,     2,
      27,     3,    33,     4,     5,    37,    38,    39,    42,    20,
      43,    44,    55,     6,    52,     7,    30,    31,     8,     9,
      32,    10,    11,    12,    34,     1,    36,     2,    41,     3,
      35,     4,     5,    60,    45,    48,    46,    49,    61,    51,
      56,     6,    57,     7,    59,    64,     8,     9,    58,    10,
      11,    12,    37,    38,    39,    37,    38,    39,    37,    38,
      39,    63,    53,     0,    62,     0,    50,     0,    54
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-19)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int8 yycheck[] =
{
       7,     4,     5,     2,     3,    19,    17,     3,     6,     5,
      25,     7,    30,     9,    10,    11,    12,    13,    21,    17,
      23,    24,    36,    19,    31,    21,     8,    15,    24,    25,
       0,    27,    28,    29,    14,     3,    26,     5,    20,     7,
      18,     9,    10,    50,     4,    27,     4,    16,    51,    20,
      17,    19,     4,    21,     8,    62,    24,    25,     6,    27,
      28,    29,    11,    12,    13,    11,    12,    13,    11,    12,
      13,    16,    34,    -1,    23,    -1,    22,    -1,    35
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     5,     7,     9,    10,    19,    21,    24,    25,
      27,    28,    29,    32,    33,    34,    35,    36,    37,    41,
      17,    40,     6,    40,    40,    33,    33,    25,    39,    41,
      39,    15,     0,    30,    14,    18,    26,    11,    12,    13,
      37,    39,    33,    33,    33,     4,     4,    38,    39,    16,
      22,    20,    41,    34,    35,    37,    17,     4,     6,     8,
      41,    33,    23,    16,    41
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (ret, yyscanner, builtins, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, ret, yyscanner, builtins); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, std::unique_ptr <tree> &ret, void *yyscanner, vocabulary const &builtins)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, ret, yyscanner, builtins)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    std::unique_ptr <tree> &ret;
    void *yyscanner;
    vocabulary const &builtins;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (ret);
  YYUSE (yyscanner);
  YYUSE (builtins);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, std::unique_ptr <tree> &ret, void *yyscanner, vocabulary const &builtins)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, ret, yyscanner, builtins)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    std::unique_ptr <tree> &ret;
    void *yyscanner;
    vocabulary const &builtins;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, ret, yyscanner, builtins);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, std::unique_ptr <tree> &ret, void *yyscanner, vocabulary const &builtins)
#else
static void
yy_reduce_print (yyvsp, yyrule, ret, yyscanner, builtins)
    YYSTYPE *yyvsp;
    int yyrule;
    std::unique_ptr <tree> &ret;
    void *yyscanner;
    vocabulary const &builtins;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , ret, yyscanner, builtins);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, ret, yyscanner, builtins); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, std::unique_ptr <tree> &ret, void *yyscanner, vocabulary const &builtins)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, ret, yyscanner, builtins)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    std::unique_ptr <tree> &ret;
    void *yyscanner;
    vocabulary const &builtins;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (ret);
  YYUSE (yyscanner);
  YYUSE (builtins);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (std::unique_ptr <tree> &ret, void *yyscanner, vocabulary const &builtins)
#else
int
yyparse (ret, yyscanner, builtins)
    std::unique_ptr <tree> &ret;
    void *yyscanner;
    vocabulary const &builtins;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;


#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
static YYSTYPE yyval_default;
# define YY_INITIAL_VALUE(Value) = Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 274 "parser.yy"
    {
    ret.reset ((yyvsp[(1) - (2)].t));
    YYACCEPT;
  }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 280 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (1)].t)};

    auto ret = maybe_nop (std::move (t1));

    (yyval.t) = ret.release ();
  }
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 292 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (3)].t)};
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (3)].t)};

    auto u1 = wrap_in_scope_unless (tree_type::ALT, maybe_nop (std::move (t1)));
    auto u3 = wrap_in_scope_unless (tree_type::ALT, maybe_nop (std::move (t3)));
    auto ret = tree::create_cat <tree_type::ALT>
		(std::move (u1), std::move (u3));

    (yyval.t) = ret.release ();
  }
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 308 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (3)].t)};
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (3)].t)};

    auto u1 = wrap_in_scope_unless (tree_type::OR, maybe_nop (std::move (t1)));
    auto u3 = wrap_in_scope_unless (tree_type::OR, maybe_nop (std::move (t3)));
    auto ret = tree::create_cat <tree_type::OR> (std::move (u1),
						 std::move (u3));

    (yyval.t) = ret.release ();
  }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 324 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (3)].t)};
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (3)].t)};
    std::string str {(yyvsp[(2) - (3)].s).buf, (yyvsp[(2) - (3)].s).len};

    auto ret = parse_op (builtins, std::move (t1), std::move (t3), str);

    (yyval.t) = ret.release ();
  }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 336 "parser.yy"
    { (yyval.t) = nullptr; }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 339 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (2)].t)};
    std::unique_ptr <tree> t2 {(yyvsp[(2) - (2)].t)};

    auto ret = tree::create_cat <tree_type::CAT> (std::move (t1),
						  std::move (t2));

    (yyval.t) = ret.release ();
  }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 351 "parser.yy"
    {
    (yyval.ids) = new std::vector <std::string> ();
  }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 359 "parser.yy"
    {
    (yyvsp[(2) - (2)].ids)->push_back (std::string {(yyvsp[(1) - (2)].s).buf, (yyvsp[(1) - (2)].s).len});
    (yyval.ids) = (yyvsp[(2) - (2)].ids);
  }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 366 "parser.yy"
    {
    (yyval.ids) = new std::vector <std::string> ();
  }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 371 "parser.yy"
    { (yyval.ids) = (yyvsp[(2) - (3)].ids); }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 375 "parser.yy"
    {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[(2) - (4)].ids)};
    size_t sz = ids->size ();
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (4)].t)};

    auto ret = tree::create_cat <tree_type::CAT>
      (tree_for_id_block (builtins, std::move (ids)),
       std::move (t3));

    if (sz > 0)
      ret = tree::create_scope (std::move (ret));

    (yyval.t) = ret.release ();
  }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 391 "parser.yy"
    {
    std::unique_ptr <tree> t2 {(yyvsp[(2) - (3)].t)};

    auto ret = tree::create_assert
      (tree::create_unary <tree_type::PRED_SUBX_ANY>
       (tree::create_scope (std::move (t2))));

    (yyval.t) = ret.release ();
  }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 402 "parser.yy"
    {
    std::unique_ptr <tree> t2 {(yyvsp[(2) - (3)].t)};

    auto ret = tree::create_assert
      (tree::create_neg
       (tree::create_unary <tree_type::PRED_SUBX_ANY>
	(tree::create_scope (std::move (t2)))));

    (yyval.t) = ret.release ();
  }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 414 "parser.yy"
    {
    auto ret = tree::create_nullary <tree_type::EMPTY_LIST> ();

    (yyval.t) = ret.release ();
  }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 421 "parser.yy"
    {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[(2) - (4)].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (4)].t)};

    auto ret = tree::create_scope
      (tree::create_cat <tree_type::CAT>
       (tree_for_id_block (builtins, std::move (ids)),

	tree::create_unary <tree_type::CAPTURE>
	(tree::create_scope (std::move (t3)))));

    (yyval.t) = ret.release ();
  }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 436 "parser.yy"
    {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[(2) - (4)].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (4)].t)};

    auto ret = tree::create_unary <tree_type::BLOCK>
      (tree::create_scope
       (tree::create_cat <tree_type::CAT>
	(tree_for_id_block (builtins, std::move (ids)),
	 std::move (t3))));

    (yyval.t) = ret.release ();
  }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 450 "parser.yy"
    {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[(2) - (3)].ids)};
    assert (ids->size () > 0);

    std::unique_ptr <tree> ret;
    for (auto const &s: *ids)
      if (builtins.find (s) == nullptr)
	ret = tree::create_cat <tree_type::CAT>
		(std::move (ret), tree::create_str <tree_type::BIND> (s));
      else
	throw std::runtime_error
	    (std::string ("Can't rebind a builtin: `") + s + "'");

    (yyval.t) = ret.release ();
  }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 467 "parser.yy"
    {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[(2) - (5)].ids)};
    std::unique_ptr <tree> t4 {(yyvsp[(4) - (5)].t)};

    auto tt = tree::create_const <tree_type::SUBX_EVAL>
      (constant {ids->size (), &dec_constant_dom});
    tt->take_child (tree::create_scope (std::move (t4)));

    auto ret = tree::create_cat <tree_type::CAT>
      (std::move (tt),
       tree_for_id_block (builtins, std::move (ids)));

    (yyval.t) = ret.release ();
  }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 483 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (2)].t)};

    auto ret = [&] () {
      switch (t1->tt ())
	{
	case tree_type::CLOSE_STAR:
	  return std::move (t1);

	case tree_type::CLOSE_PLUS:
	  t1->m_tt = tree_type::CLOSE_STAR;
	  return std::move (t1);

	default:
	  return tree::create_unary <tree_type::CLOSE_STAR>
			(tree::create_scope (std::move (t1)));
	}
    } ();

    (yyval.t) = ret.release ();
  }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 506 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (2)].t)};

    auto ret = (t1->tt () == tree_type::CLOSE_STAR
		|| t1->tt () == tree_type::CLOSE_PLUS)
      ? std::move (t1)
      : tree::create_unary <tree_type::CLOSE_PLUS>
		(tree::create_scope (std::move (t1)));

    (yyval.t) = ret.release ();
  }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 519 "parser.yy"
    {
    std::unique_ptr <tree> t1 {(yyvsp[(1) - (2)].t)};
    std::unique_ptr <tree> n {nop ()};
    (yyval.t) = tree::create_cat <tree_type::ALT>
	(std::move (t1), std::move (n)).release ();
  }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 527 "parser.yy"
    {
    std::unique_ptr <tree> t2 {(yyvsp[(2) - (6)].t)};
    std::unique_ptr <tree> t4 {(yyvsp[(4) - (6)].t)};
    std::unique_ptr <tree> t6 {(yyvsp[(6) - (6)].t)};

    auto ret = tree::create_ternary <tree_type::IFELSE>
      (tree::create_scope (std::move (t2)),
       tree::create_scope (std::move (t4)),
       tree::create_scope (std::move (t6)));

    (yyval.t) = ret.release ();
  }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 541 "parser.yy"
    { (yyval.t) = tree::create_const <tree_type::CONST> (parse_int ((yyvsp[(1) - (1)].s))).release (); }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 544 "parser.yy"
    { (yyval.t) = parse_word (builtins, {(yyvsp[(1) - (1)].s).buf, (yyvsp[(1) - (1)].s).len}).release (); }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 547 "parser.yy"
    {
    std::unique_ptr <tree> t1 {parse_word (builtins, {(yyvsp[(1) - (3)].s).buf, (yyvsp[(1) - (3)].s).len})};
    std::unique_ptr <tree> t3 {(yyvsp[(3) - (3)].t)};
    (yyval.t) = tree::create_cat <tree_type::CAT>
	(std::move (t3), std::move (t1)).release ();
  }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 555 "parser.yy"
    {
    // For string literals, we get back a tree_type::FMT node with
    // children that are a mix of tree_type::STR (which are actual
    // literals) and other node types with the embedded programs.
    // That comes directly from lexer, just return it.
    (yyval.t) = (yyvsp[(1) - (1)].t);
  }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 565 "parser.yy"
    {
    auto ret = tree::create_nullary <tree_type::F_DEBUG> ();

    (yyval.t) = ret.release ();
  }
    break;


/* Line 1792 of yacc.c  */
#line 2069 "/builddir/build/BUILD/dwgrep-0.2/build/libzwerg/parser.cc"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (ret, yyscanner, builtins, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (ret, yyscanner, builtins, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, ret, yyscanner, builtins);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, ret, yyscanner, builtins);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (ret, yyscanner, builtins, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, ret, yyscanner, builtins);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, ret, yyscanner, builtins);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 571 "parser.yy"


struct lexer
{
  yyscan_t m_sc;

  explicit lexer (vocabulary const &builtins,
		  char const *begin, char const *end)
  {
    if (yylex_init_extra (&builtins, &m_sc) != 0)
      throw std::runtime_error ("Can't init lexer.");
    yy_scan_bytes (begin, end - begin, m_sc);
  }

  ~lexer ()
  {
    yylex_destroy (m_sc);
  }

  lexer (lexer const &that) = delete;
};

tree
parse_query (vocabulary const &builtins, std::string str)
{
  char const *buf = str.c_str ();
  return parse_query (builtins, buf, buf + str.length ());
}

tree
parse_subquery (vocabulary const &builtins, std::string str)
{
  char const *buf = str.c_str ();
  return parse_subquery (builtins, buf, buf + str.length ());
}

tree
parse_query (vocabulary const &builtins,
	     char const *begin, char const *end)
{
  return tree::resolve_scopes (parse_subquery (builtins, begin, end));
}

tree
parse_subquery (vocabulary const &builtins,
		char const *begin, char const *end)
{
  lexer lex {builtins, begin, end};
  std::unique_ptr <tree> t;
  if (yyparse (t, lex.m_sc, builtins) == 0)
    return *t;
  throw std::runtime_error ("syntax error");
}
